export declare namespace SetUtils {
    type ElementPresenceChecker = <Element extends Value, Value>(array: ReadonlyArray<Element>, value: Value) => boolean;
}
export declare namespace ObjectUtils {
    type KeyLister = <Object extends GenericObject, Key extends keyof Object>(object: Object) => ReadonlyArray<Key>;
    type ValLister = <Object extends GenericObject, Key extends keyof Object>(object: Object) => ReadonlyArray<Object[Key]>;
    interface GenericObject {
        [key: string]: any;
    }
}
export declare namespace FunctionUtils {
    type RecursiveReturn<Return, Args extends any[]> = Return | ((...args: Args) => RecursiveReturn<Return, Args>);
}
export declare namespace TupleUtils {
    type SplitFirstOne<Tuple> = Tuple extends [infer First, ...(infer Rest)[]] ? [First, Rest[]] : never;
    type FirstElement<Tuple extends utils.Least[1]> = SplitFirstOne<Tuple>[0];
    type ExcludeFirstElement<Tuple extends utils.Least[1]> = SplitFirstOne<Tuple>[1];
    namespace utils {
        type Least<X = any> = [X[], [X, ...X[]], [X, X, ...X[]], [X, X, X, ...X[]]];
    }
}
